
{
  If you were **not** install HyperReport Version 3.5.0 or later yet,
  **remove** 'HyperReport350' compiler directive line.
}

{$DEFINE StdReg}
{$DEFINE DBReg}
{$DEFINE Win31Reg}
{$DEFINE SysReg}
{$DEFINE OleReg}
{$DEFINE DDEReg}
{$DEFINE HyperReport350}  { for HyperReport 3.5.0 users }
{$DEFINE HyperLibrary}
{$DEFINE OCX}             { for Delphi 2 }
{$DEFINE IBReg}
{$DEFINE SampReg}

unit Sample;

interface

uses
  {$IFDEF WIN32} Windows, ComCtrls, {$ELSE} WinTypes, WinProcs, {$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Menus,
  HLClass, HLTbNtBk, HLFrmDsg, Tabs, ExtCtrls;

type
  TSamplef = class(TForm)
    BitBtn1: TBitBtn;
    Button2: TButton;
    BitBtn2: TBitBtn;
    Button3: TButton;
    Label1: TLabel;
    HLFormDesigner1: THLFormDesigner;
    Button4: TButton;
    Button1: TButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    {HLFormDesigner1: THLFormDesigner;}
    procedure RegComp;
    procedure ReadDcrFiles;
  protected
  public
  end;

var
  Samplef: TSamplef;

implementation

{$R *.DFM}

uses
  TypInfo, DsgnIntf, Consts, HLStrEdt, HLPicEdt,
  {$IFDEF VER80} HLDSDs80, {$ELSE}HLDSDsgn,{$ENDIF}
  {$IFDEF VER90} MaskText, MaskProp, LibConst, FileCtrl,{$ENDIF}

{$IFDEF StdReg}
  {$IFDEF VER80}
  Outline, TabNotBk,
  NoteBReg, PageEdit,
  MnuBuild, MaskText, MaskProp, PicEdit, LibConst,
  {$ENDIF}

  {$IFDEF VER90}
  PicEdit,
  PageEdit, SBarEdit, ColEdit, ItemEdit,
  ImgList, NodeEdit, HCtlEdit,
  {$ENDIF}
  Mask, Grids,
{$ENDIF}

{$IFDEF DBReg}

  {EditIntf, ExptIntf, ToolIntf,}
  DBConsts, DB, DBTables, DBCtrls, DBGrids, DBLookup,
  {$IFDEF WIN32} DBCGrids, {$ENDIF}

  {$IFDEF VER80}
  {DSDesign, }
  Report, DBEdit, FldLinks,
  QBE, QBindDlg, ProcDlg,
  {$ENDIF}

  {$IFDEF VER90}
  {DSDesign, DBExpt, DBInpReq, DbxTarg,}
  Report, DBEdit, FldLinks,
  QBE, QBindDlg, ProcDlg, IxEdit, dbColEdt, UpdSqlEd, DbXPlor,
  {$ENDIF}

  {$IFDEF VER100}
  BdeConst,
  {$ENDIF}

{$ENDIF}

{$IFDEF WIN32}
{$IFDEF Win31Reg}
  {$IFDEF VER90}
  Win31Reg, NoteBReg,
  {$ENDIF}
  Outline, Tabnotbk,
{$ENDIF}
{$ENDIF}

{$IFDEF SysReg}
  {$IFDEF VER90}
  FiltEdit, MPlayer,
  {$ENDIF}
{$ENDIF}

{$IFDEF OleReg}
  {$IFDEF VER80}  Ole2, Ole, ToCtrl, ToUnk, BCom, BoleDefs, BoleIntf, ToIntf, ToConsts, Proxies, LibHelp,{$ENDIF}
  {$IFDEF VER90}  Ole2, OleAuto, OleCtnrs, {$ENDIF}
  {$IFDEF VER100} OleCtrls, ActiveX, OleCtnrs, {$ENDIF}
{$ENDIF}

{$IFDEF DDEReg}
  {$IFDEF VER90}
  DDEReg,
  {$ENDIF}
  DdeMan,
{$ENDIF}

{$IFDEF OCX}
  {$IFDEF VER90}
  ChartFX, VCFIMPRS, VCFRMLA1, VCSPELL, GRAPHSVR,
  {$ENDIF}
{$ENDIF}

{$IFDEF IBReg}
  {$IFDEF WIN32}
  IBEvnts, IBCtrls,
  {$ENDIF}
{$ENDIF}

{$IFDEF HyperReport350}
  HRClass, HRCommon, HRCtrlsC, HRLinkC, HRGridC, HROleC, HRPrtC, HReport,
  HRPreVC, HRPreVU, HRepreg,
  {$IFDEF WIN32} HRRichC, {$ENDIF}
{$ENDIF}

{$IFDEF HyperLibrary}
  HLObjIns,
{$ENDIF}

{$IFDEF SampReg}
  Calendar, DirOutln, Spin, ColorGrd, Gauges,
{$ENDIF}
  SampleTN;
{/////////////////////////////////////////////////////////}

{$IFDEF StdReg}
  {$I StdReg.Inc}
{$ENDIF}

{$IFDEF DBReg}
  {$I DBReg.Inc}
{$ENDIF}

{$IFDEF OLEReg}
  {$I OleReg.Inc}
{$ENDIF}

{$IFDEF IBReg}
  {$IFDEF WIN32} {$I IBReg.Inc} {$ENDIF}
{$ENDIF}


{$IFDEF VER100}
function LoadStr(str: string): string;
begin
  Result := str;
end;

const
  srStandard = 'Standard';
  srAdditional = 'Additional';
  srWin95 = 'Win95';
  srDAccess = 'Data Access';
  srDControls = 'Data Controls';
  srWin31 = 'Win31';
  srDialogs = 'Dialogs';
  srSystem = 'System';
  srSamples = 'Samples';
{$ENDIF}

procedure TSamplef.RegComp;
begin
  {$IFDEF VER100}
  RegisterPropertyEditor(TypeInfo(TComponent), nil, '', TComponentProperty);
  RegisterPropertyEditor(TypeInfo(TComponentName), nil, '', TComponentNameProperty);
  RegisterPropertyEditor(TypeInfo(TFontName), nil, '', TFontNameProperty);
  RegisterPropertyEditor(TypeInfo(TFontCharset), nil, '', TFontCharsetProperty);
  RegisterPropertyEditor(TypeInfo(TImeName), nil, '', TImeNameProperty);
  RegisterPropertyEditor(TypeInfo(TColor), nil, '', TColorProperty);
  RegisterPropertyEditor(TypeInfo(TCursor), nil, '', TCursorProperty);
  RegisterPropertyEditor(TypeInfo(TFont), nil, '', TFontProperty);
  RegisterPropertyEditor(TypeInfo(TModalResult), nil, '', TModalResultProperty);
  RegisterPropertyEditor(TypeInfo(TShortCut), nil, '', TShortCutProperty);
  RegisterPropertyEditor(TypeInfo(TTabOrder), nil, '', TTabOrderProperty);
  RegisterPropertyEditor(TypeInfo(TCaption), nil, '', TCaptionProperty);
  RegisterPropertyEditor(TypeInfo(TDate), nil, '', TDateProperty);
  RegisterPropertyEditor(TypeInfo(TTime), nil, '', TTimeProperty);
  RegisterPropertyEditor(TypeInfo(TDateTime), nil, '', TDateTimeProperty);
  RegisterPropertyEditor(TypeInfo(TPicture), nil, '', TGraphicProperty);
  RegisterPropertyEditor(TypeInfo(TBitmap), nil, '', TGraphicProperty);
  RegisterPropertyEditor(TypeInfo(TIcon), nil, '', TGraphicProperty);
  {$ENDIF}

{$IFDEF StdReg}
  {$IFDEF VER80}
  RegisterComponents(LoadStr(srStandard), [TMainMenu, TPopupMenu, TLabel,
    TEdit, TMemo, TButton, TCheckBox, TRadioButton, TListBox, TComboBox,
    TScrollBar, TGroupBox, TRadioGroup, TPanel]);
  RegisterComponents(LoadStr(srAdditional), [TBitBtn, TSpeedButton, TTabSet,
    TNotebook, TTabbedNotebook, TMaskEdit, TOutline, TStringGrid, TDrawGrid, 
    TImage, TShape, TBevel, THeader, TScrollBox]);

  RegisterNoIcon([TMenuItem]);

  RegisterComponentEditor(TMenu, TMenuEditor);
  RegisterComponentEditor(TImage, TGraphicEditor);
  RegisterComponentEditor(TNotebook, TNotebookEditor);
  RegisterComponentEditor(TTabbedNotebook, TTabbedNotebookEditor);

  RegisterPropertyEditor(TypeInfo(string), TNotebook, 'ActivePage', TPageNameProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TNotebook, 'Pages', TPageListProperty);
  RegisterPropertyEditor(TypeInfo(string), TCustomMaskEdit, 'EditMask', TMaskProperty);
  RegisterPropertyEditor(TypeInfo(string), TCustomMaskEdit, 'Text', TMaskTextProperty);
  RegisterPropertyEditor(TypeInfo(string), TTabbedNotebook, 'ActivePage', TTabPageNameProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TTabbedNotebook, 'Pages',    TTabPageListProperty);
  {$ELSE}
  RegisterComponents(LoadStr(srStandard), [TMainMenu, TPopupMenu, TLabel,
    TEdit, TMemo, TButton, TCheckBox, TRadioButton, TListBox, TComboBox,
    TScrollBar, TGroupBox, TRadioGroup, TPanel]);

  RegisterComponents(LoadStr(srAdditional), [TBitBtn, TSpeedButton,
    TMaskEdit, TStringGrid, TDrawGrid, TImage, TShape, TBevel,
    TScrollBox]);

  RegisterComponents(LoadStr(srWin95), [TTabControl, TPageControl,
    TTreeView, TListView, TImageList, THeaderControl, TRichEdit,
    TStatusBar, TTrackBar, TProgressBar, TUpDown, THotKey]);

  RegisterClasses([TTabSheet]);

  RegisterNoIcon([TMenuItem]);

  {$IFDEF VER100}
  RegisterComponentEditor(TImage, TGraphicEditor);
  {$ENDIF}
  {$IFDEF VER90}
  {RegisterComponentEditor(TMenu, TMenuEditor);}
  RegisterComponentEditor(TImage, TGraphicEditor);

  RegisterComponentEditor(TPageControl, TPageControlEditor);
  RegisterComponentEditor(TTabSheet, TPageControlEditor);
  RegisterComponentEditor(TImageList, TImageListEditor);

  RegisterPropertyEditor(TypeInfo(string), TCustomMaskEdit, 'EditMask', TMaskProperty);
  RegisterPropertyEditor(TypeInfo(string), TCustomMaskEdit, 'Text', TMaskTextProperty);

  RegisterPropertyEditor(TypeInfo(TTabSheet), TPageControl, 'ActivePage', TActivePageProperty);
  RegisterPropertyEditor(TypeInfo(TStatusPanels), nil, '', TStatusPanelsProperty);
  RegisterPropertyEditor(TypeInfo(THeaderSections), nil, '', THeaderSectionsProperty);
  RegisterPropertyEditor(TypeInfo(TListColumns), nil, '', TListColumnsProperty);
  RegisterPropertyEditor(TypeInfo(TListItems), nil, '', TListItemsProperty);
  RegisterPropertyEditor(TypeInfo(TTreeNodes), nil, '', TTreeNodesProperty);
  {$ENDIF}
  {$ENDIF}
{$ENDIF}

  RegisterPropertyEditor(TypeInfo(TStrings), nil, '', TStringsProperty);

{$IFDEF DBReg}
  {$IFDEF VER80}
  RegisterComponents(LoadStr(srDAccess), [TDataSource, TTable, TQuery,
    TStoredProc, TDatabase, TBatchMove, TReport]);
  RegisterComponents(LoadStr(srDControls), [TDBGrid, TDBNavigator, TDBText,
    TDBEdit, TDBMemo, TDBImage, TDBListBox, TDBComboBox,
    TDBCheckBox, TDBRadioGroup, TDBLookupList, TDBLookupCombo]);
  RegisterNoIcon([TField]);
  RegisterNoIcon([TStringField, TIntegerField, TSmallintField, TWordField,
    TFloatField, TCurrencyField, TBCDField, TBooleanField, TDateField,
    TVarBytesField, TBytesField, TTimeField, TDateTimeField,
    TBlobField, TMemoField, TGraphicField]);
  RegisterPropertyEditor(TypeInfo(TDataSet), TDataSource, 'DataSet', TDataSetProperty);
  RegisterPropertyEditor(TypeInfo(TDataSource), TTable, 'MasterSource', TDataSourceProperty);
  RegisterPropertyEditor(TypeInfo(TDataSource), TQuery, 'DataSource', TDataSourceProperty);
  RegisterPropertyEditor(TypeInfo(TSymbolStr), TDatabase, 'AliasName', TAliasNameProperty);
  RegisterPropertyEditor(TypeInfo(TSymbolStr), TDatabase, 'DriverName', TDriverNameProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TDBDataSet, 'DatabaseName', TDatabaseNameProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TTable, 'TableName', TTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTable, 'IndexName', TIndexNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTable, 'IndexFieldNames', TIndexFieldNamesProperty);
  RegisterPropertyEditor(TypeInfo(string), TComponent, 'DataField', TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TWinControl, 'LookupField', TLookupIndexProperty);
  RegisterPropertyEditor(TypeInfo(string), TWinControl, 'LookupDisplay', TLookupFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TDBEdit, 'EditMask', TMaskProperty);
  RegisterPropertyEditor(TypeInfo(string), TField, 'EditMask', TMaskProperty);
  RegisterPropertyEditor(TypeInfo(string), TReport, 'ReportDir', TReportDirProperty);
  RegisterPropertyEditor(TypeInfo(string), TReport, 'ReportName', TReportNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTable, 'MasterFields', TFieldLinkProperty);
  RegisterPropertyEditor(TypeInfo(string), TQuery, 'StoredProcName', TProcedureNameProperty);
  RegisterPropertyEditor(TypeInfo(TParams), TQuery, 'Params', TQueryParamsProperty);
  RegisterPropertyEditor(TypeInfo(string), TStoredProc, 'StoredProcName', TProcedureNameProperty);
  RegisterPropertyEditor(TypeInfo(TParams), TStoredProc, 'Params', TStoredParamsProperty);
  RegisterComponentEditor(TDataset, TDataSetEditor);
  RegisterComponentEditor(TDatabase, TDatabaseEditor);
  RegisterComponentEditor(TBatchMove, TBatchMoveEditor);
  RegisterComponentEditor(TReport, TReportEditor);
  RegisterComponentEditor(TDBImage, TDBImageEditor);
  RegisterComponentEditor(TQuery, TQueryEditor);
  RegisterComponentEditor(TStoredProc, TStoredProcEditor);
  {$ELSE}
  RegisterComponents(LoadStr(srDAccess), [TDataSource, TTable, TQuery,
    TStoredProc, TDatabase, TSession, TBatchMove, TUpdateSQL]);
  RegisterComponents(LoadStr(srDControls), [TDBGrid, TDBNavigator, TDBText,
    TDBEdit, TDBMemo, TDBImage, TDBListBox, TDBComboBox, TDBCheckBox,
    TDBRadioGroup, TDBLookupListBox, TDBLookupComboBox]);

  {$IFDEF VER90}
  RegisterComponents(LoadStr(srDAccess), [TReport]);
  RegisterComponents(LoadStr(srDControls), [TDBCtrlGrid]);
  RegisterComponents(LoadStr(srWin31), [TDBLookupList, TDBLookupCombo]);
  {$ENDIF}

  RegisterNoIcon([TField]);

  RegisterNoIcon([TStringField, TIntegerField, TSmallintField, TWordField,
    TFloatField, TCurrencyField, TBCDField, TBooleanField, TDateField,
    TVarBytesField, TBytesField, TTimeField, TDateTimeField,
    TBlobField, TMemoField, TGraphicField, TAutoIncField]);

  RegisterPropertyEditor(TypeInfo(TDataSet), TDataSource, 'DataSet', TDataSetProperty);
  RegisterPropertyEditor(TypeInfo(TDataSource), TTable, 'MasterSource', TDataSourceProperty);
  RegisterPropertyEditor(TypeInfo(TDataSource), TQuery, 'DataSource', TDataSourceProperty);
  RegisterPropertyEditor(TypeInfo(string), TDatabase, 'AliasName', TAliasNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TDatabase, 'DriverName', TDriverNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TDatabase, 'SessionName', TSessionNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TDBDataSet, 'SessionName', TSessionNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TDBDataSet, 'DatabaseName', TDatabaseNameProperty);
  RegisterPropertyEditor(TypeInfo(TDataSetUpdateObject), TDataSet, 'UpdateObject', TComponentProperty);
  RegisterPropertyEditor(TypeInfo(string), TTable, 'TableName', TTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTable, 'IndexName', TIndexNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTable, 'IndexFieldNames', TIndexFieldNamesProperty);
  RegisterPropertyEditor(TypeInfo(string), TField, 'KeyFields', TLookupSourceProperty);
  RegisterPropertyEditor(TypeInfo(string), TField, 'LookupKeyFields', TLookupDestProperty);
  RegisterPropertyEditor(TypeInfo(string), TField, 'LookupResultField', TLookupDestProperty);
  RegisterPropertyEditor(TypeInfo(string), TComponent, 'DataField', TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TDBLookupControl, 'KeyField', TListFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TDBLookupControl, 'ListField', TListFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TWinControl, 'LookupField', TLookupIndexProperty);
  RegisterPropertyEditor(TypeInfo(string), TWinControl, 'LookupDisplay', TLookupFieldProperty);
  {$IFDEF VER90}
  RegisterPropertyEditor(TypeInfo(string), TDBEdit, 'EditMask', TMaskProperty);
  RegisterPropertyEditor(TypeInfo(string), TField, 'EditMask', TMaskProperty);
  RegisterPropertyEditor(TypeInfo(string), TReport, 'ReportDir', TReportDirProperty);
  RegisterPropertyEditor(TypeInfo(string), TReport, 'ReportName', TReportNameProperty);
  RegisterComponentEditor(TReport, TReportEditor);
  RegisterPropertyEditor(TypeInfo(string), TTable, 'MasterFields', TFieldLinkProperty);
  {$ENDIF}
  RegisterPropertyEditor(TypeInfo(TParams), TQuery, 'Params', TQueryParamsProperty);
  RegisterPropertyEditor(TypeInfo(string), TStoredProc, 'StoredProcName', TProcedureNameProperty);
  RegisterPropertyEditor(TypeInfo(TParams), TStoredProc, 'Params', TStoredParamsProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TTable, 'IndexFiles', TIndexFilesProperty);
  RegisterPropertyEditor(TypeInfo(TDBGridColumns), nil, '', TDBColumnAttributesProperty);
  RegisterComponentEditor(TDataset, TDataSetEditor);
  RegisterComponentEditor(TDatabase, TDatabaseEditor);
  RegisterComponentEditor(TBatchMove, TBatchMoveEditor);
  RegisterComponentEditor(TQuery, TQueryEditor);
  RegisterComponentEditor(TDBImage, TDBImageEditor);
  RegisterComponentEditor(TStoredProc, TStoredProcEditor);
  RegisterComponentEditor(TDBGrid, TDBGridEditor);
  RegisterComponentEditor(TUpdateSQL, TUpdateSQLEditor);
  //DBExpt.Register;
  {$ENDIF}
{$ENDIF}

{$IFDEF WIN32}
{$IFDEF Win31Reg}
  RegisterComponents(LoadStr(srWin31), [TTabSet, TOutline,
    THeader, TTabbedNotebook, TNotebook]);

  {$IFDEF VER90}
  RegisterComponentEditor(TNotebook, TNotebookEditor);
  RegisterComponentEditor(TTabbedNotebook, TTabbedNotebookEditor);
  RegisterPropertyEditor(TypeInfo(string), TNotebook, 'ActivePage', TPageNameProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TNotebook, 'Pages', TPageListProperty);
  RegisterPropertyEditor(TypeInfo(string), TTabbedNotebook, 'ActivePage', TTabPageNameProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TTabbedNotebook, 'Pages',    TTabPageListProperty);
  {$ENDIF}
{$ENDIF}
{$ENDIF}

{$IFDEF SysReg}
  RegisterComponents(LoadStr(srDialogs), [TOpenDialog, TSaveDialog, TFontDialog,
    TColorDialog, TPrintDialog, TPrinterSetupDialog, TFindDialog,
    TReplaceDialog]);

  {$IFDEF VER90}
  RegisterComponents(LoadStr(srSystem), [TTimer, TPaintBox, TFileListBox,
    TDirectoryListBox, TDriveComboBox, TFilterComboBox, TMediaPlayer]);
  RegisterPropertyEditor(TypeInfo(string), TFilterComboBox, 'Filter', TFilterProperty);
  RegisterPropertyEditor(TypeInfo(string), TOpenDialog, 'Filter', TFilterProperty);
  RegisterPropertyEditor(TypeInfo(string), TMediaPlayer, 'Filename', TMPFilenameProperty);
  {$ENDIF}
{$ENDIF}

{$IFDEF OLEReg}
  {$IFDEF VER80}
  LibOleHelper := TLibOle.Create;
  RegisterComponents(LoadStr(srSystem), [TOleContainer]);
  RegisterPropertyEditor(TypeInfo(string), TOleContainer, 'ObjClass', TOleObjTypeProperty);
  RegisterPropertyEditor(TypeInfo(string), TOleContainer, 'ObjDoc', TOleObjTypeProperty);
  RegisterPropertyEditor(TypeInfo(string), TOleContainer, 'ObjItem', TOleObjItemProperty);
  RegisterComponentEditor(TOleContainer, TOleEditor);
  {$ELSE}
  RegisterComponents(LoadStr(srSystem), [TOleContainer]);
  RegisterComponentEditor(TOleContainer, TOleContainerEditor);
  {$ENDIF}
{$ENDIF}

{$IFDEF DDEReg}
  RegisterComponents(LoadStr(srSystem),
            [TDdeClientConv, TDdeClientItem, TDdeServerConv, TDdeServerItem]);

  {$IFDEF VER90}
  RegisterPropertyEditor(TypeInfo(string), TDdeClientConv, 'DdeService', TDdeLinkInfoProperty);
  RegisterPropertyEditor(TypeInfo(string), TDdeClientConv, 'DdeTopic', TDdeLinkInfoProperty);
  RegisterPropertyEditor(TypeInfo(string), TDdeClientItem, 'DdeItem', TDdeClientItemProperty);
  RegisterComponentEditor(TDdeServerItem, TSrvrItemEdit);
  RegisterComponentEditor(TDdeServerConv, TSrvrConvEdit);
  RegisterComponentEditor(TDdeClientConv, TCliConvEdit);
  {$ENDIF}
{$ENDIF}

{$IFDEF HyperReport350}
  RegisterNoIcon( [THRField] );
  RegisterClasses( [THRField] );
  RegisterComponents('HyperReport', [THRPage, THRPageBand, THRGroup, THRGroupBand,
       THRLabel, THRMemo, {$IFDEF WIN32}THRRichMemo,{$ENDIF}
       THRImage, THRBarCode, THRCheckBox,
       THRStringGrid, THROleContainer,
       THRDBText, THRDBMemo, {$IFDEF WIN32}THRDBRichMemo,{$ENDIF}
       THRDBImage, THRDBBarcode, THRDBCheckBox,
       THRDBOleContainer,
       THRCalc, THRSysData, THRLink, THyperReport,
       THRPreview, THRPreviewControl]);

  RegisterComponentEditor(THRImage, TGraphicEditor);
  RegisterPropertyEditor(TypeInfo(THRPageInfo), THRPage, 'PageInfo', THRPageInfoProperty);
  RegisterPropertyEditor(TypeInfo(THRMargineSize), nil, '', THRMargineSizeProperty);
  RegisterPropertyEditor(TypeInfo(THRSelectRect ), nil, '', THRSelectRectProperty);
  RegisterPropertyEditor(TypeInfo(THRGroupStyle), THRGroup, 'GroupStyle', THRGroupStyleProperty);
  RegisterPropertyEditor(TypeInfo(THRLinkInfo), THRLink, 'LinkInfo', THRLinkInfoProperty);

  RegisterComponentEditor(THRPage, THRPageEditor);
  RegisterComponentEditor(THRGroup, THRGroupStyleEditor);
  RegisterComponentEditor(THRLink, THRLinkInfoEditor);
  RegisterComponentEditor(THyperReport, THyperReportEditor);
  RegisterComponentEditor(THRStringGrid, THRStringGridEditor);
{$ENDIF}

{$IFDEF HyperLibrary}
  RegisterNoIcon([THLSpeedButton]);
  RegisterComponents('', [THLTabbedNotebook, THLObjectInspector, THLFormDesigner]);
{$ENDIF}

{$IFDEF OCX}
  {$IFDEF VER90}
  RegisterComponents('OCX', [TChartFX, TVCFirstImpression, TVCFormulaOne,
       TVCSpeller, TGraphicsServer]);
  {$ENDIF}
{$ENDIF}

{$IFDEF IBReg}
  {$IFDEF WIN32}
  RegisterComponents(LoadStr(srSamples), [TIBEventAlerter]);
  RegisterPropertyEditor(TypeInfo(TStrings), TIBEventAlerter, 'Events', TIBEventListProperty);
  {$ENDIF}
{$ENDIF}

{$IFDEF SampReg}
  RegisterComponents(LoadStr(srSamples), [TGauge, TColorGrid,
    TSpinButton, TSpinEdit, TDirectoryOutline, TCalendar]);
{$ENDIF}

end;

procedure TSamplef.ReadDcrFiles;
begin
    ReadDCRFile('hlbutton.dcr');
    {$IFDEF STDREG}  ReadDCRFile('stdreg.dcr');{$ENDIF}
    {$IFDEF DBREG}   ReadDCRFile('dbreg.dcr');{$ENDIF}
    {$IFDEF Win31Reg}ReadDCRFile('win31reg.dcr');{$ENDIF}
    {$IFDEF SysReg}  ReadDCRFile('sysreg.dcr');{$ENDIF}
    {$IFDEF DDEReg}  ReadDCRFile('ddereg.dcr');{$ENDIF}
    {$IFDEF OleReg}  ReadDCRFile('olereg.dcr');{$ENDIF}
    {$IFDEF HyperReport350}ReadDCRFile('hrepreg.dcr');{$ENDIF}
    {$IFDEF OCX}     ReadDCRFile('chartfx.dcr');{$ENDIF}
    {$IFDEF OCX}     ReadDCRFile('vcfimprs.dcr');{$ENDIF}
    {$IFDEF OCX}     ReadDCRFile('vcfrmla1.dcr');{$ENDIF}
    {$IFDEF OCX}     ReadDCRFile('vcspell.dcr');{$ENDIF}
    {$IFDEF OCX}     ReadDCRFile('graphsvr.dcr');{$ENDIF}
    {$IFDEF IBReg}   ReadDCRFile('ibreg.dcr');{$ENDIF}
    {$IFDEF SampReg} ReadDCRFile('sampreg.dcr');{$ENDIF}
end;

{ Create }

procedure TSamplef.FormShow(Sender: TObject);
begin
  try
    ReadDcrFiles;
  finally
    RegComp;
  end;
end;

procedure TSamplef.BitBtn1Click(Sender: TObject);
begin
  HLFormDesigner1.Show
end;

procedure TSamplef.BitBtn2Click(Sender: TObject);
begin
  HLFormDesigner1.Hide;
end;

procedure TSamplef.Button1Click(Sender: TObject);
begin
  HLFormDesigner1.NewForm;
end;

procedure TSamplef.Button2Click(Sender: TObject);
begin
  HLFormDesigner1.OpenForm('SampleS.DFM');
end;

procedure TSamplef.Button3Click(Sender: TObject);
begin
  HLFormDesigner1.EditForm(SampleTNf);
end;

procedure TSamplef.Button4Click(Sender: TObject);
begin
  SampleTNf.Show;
end;

procedure TSamplef.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  HLFormDesigner1.CloseQuery(Sender, CanClose);
end;

end.
